inidata1 ; disp('Jeu de donnes inidata1'); disp(' ') ;
global Poids FqMin FqMax Qmes itermax Nq
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%     ANALYSE DE LA CONFIGURATION INITIALE     %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Dab = eye(4);
disp('ANALYSE DE LA CONFIGURATION INITIALE');disp(' ');
% Longueur des cbles et matrice cinmatique correspondante
[Q P] = Dab2QetP(Dab) ;
disp(['Longueur initiale des cbles : ']);
disp(Q');
A = P'; AAt = A*P ;
Det = det(AAt) ;
disp(['Dterminant AAt : ' num2str(Det)]); disp(' ');
if Det < 10*eps
   disp('Configuration initiale singulire.');
   disp('On arrte tout !!!') ;
   return ;
end
% Pseudo-inverse de Moore-Penrose de Pt
iP = P*inv(AAt);
% Tension des cbles de Norme minimale qui quilibre le poids
disp('Recheche de la tension des cbles qui quilibrent le poids');
FxPoids = [0 0 -Poids 0 0 0]';
Fq = iP*FxPoids;
% Impression des index des cbles non tendus
Ineg = Fq < 0 ;
if sum(Ineg) ~= 0
   disp('La solution de norme minimale a des cbles non tendus : ');
	disp(Fq');
end
% Analyse du noyau. Est-il coopratif ?
Noy = null(A) ; Noy = Noy*(Noy'*ones(Nq,1)) ;
if sum(Noy < 0) ~= 0
   disp('Il y a des composantes du noyau ngatives !!');
   disp('Le noyau n''est pas coopratif. Rien  faire !!');
else
   disp('Le noyau est coopratif : ');
   disp(Noy');
	% Si existe des cbles non tendus, on les tend au minimum
	[fNeg i] = min(Fq);
	if fNeg < FqMin
   	%coef = (FqMin - fNeg )/Noy(i) ;
		coef = max((FqMin-Fq)./Noy) ;
   	Fq = Fq + coef*Noy;
	end
	disp(['Tension minimale accepte : ' num2str(FqMin)]);
	disp(['Tension des cbles : ']);
	disp(Fq');   
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%     RECHERCHE DE LA SITUATION COURANTE       %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
disp('RECHERCHE DE LA SITUATION COURANTE');disp(' ');
% Calcul Situation pour Q = Qmes
[Dab iter] = Qmes2Dab(Qmes, itermax, eye(4)) ;
if (iter == 0)
   disp(['Echec rsolution aprs ' num2str(itermax) ' itrations !']); disp(' ');
else
   if iter < 0
      disp(['Divergence aprs ' num2str(-iter) ' itrations !']); disp(' ');
   else
      disp(['Convergence aprs ' num2str(iter) ' itrations !']); disp(' ');
   end
end

disp(['Position trouve : ', num2str(Dab(1:3,4)')]);
disp(['Attitude zyx trouve : ', num2str(Mat2Carol(Dab(1:3,1:3),zeros(1,3)))]);
[Q P] = Dab2QetP(Dab) ;
disp(['Longueur mesure des cbles : ']);
disp(Qmes');
disp(['Longueur trouve des cbles : ']);
disp(Q');
disp('ANALYSE DE LA SITUATION COURANTE');disp(' ');
Det = det(P'*P) ;
disp(['Dterminant AAt : ' num2str(Det)]); disp(' ');
if Det < 10*eps
   disp('Configuration trouve singulire.');
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%      ETUDE  DU DOMAINE ATTEIGNABLE           %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
letmin='xyz';
letmaj='XYZ';
disp ('Domaine oprationnel :');
figure(1);
pas = 0.002;
ps10=pas/10.;
for ix = 1:3
    TabDet = [];
    TabX = [];
    TabNmin = [];
    TabFmax = [];
    Dab = eye(4);
    % Excursion positive
    while 1==1
        Dab(ix,4) = Dab(ix,4) + pas ;
        [Fq Det nmin] = DabetFx2Fq(Dab,FxPoids) ;
        if isempty(Fq) break ; end
        TabX = [TabX Dab(ix,4)];
        TabDet = [TabDet Det] ;
        TabNmin = [TabNmin nmin];
        fmax = max(Fq);
        TabFmax = [TabFmax fmax];
        if fmax > FqMax, continue; end
        xmax = Dab(ix,4);
    end
    % Excursion ngative
    Dab(ix,4) = pas ;
    while 1==1
        Dab(ix,4) = Dab(ix,4) - pas ;
	    [Fq Det nmin] = DabetFx2Fq(Dab,FxPoids) ;
        if isempty(Fq) break ; end
        TabX = [Dab(ix,4) TabX];
        TabDet = [Det TabDet] ;
        TabNmin = [nmin TabNmin];
        fmax = max(Fq);
        TabFmax = [fmax TabFmax];
        if fmax > FqMax, continue; end
        xmin = Dab(ix,4);
    end
    subplot(3,3,ix); plot(TabX,TabDet);     grid on; if ix==1, ylabel('Det. Pt*P'); end
    subplot(3,3,ix+3); plot(TabX,TabNmin);  grid on; if ix==1, ylabel('Ni min'); end
    imin = find((TabX <= xmin+ps10) & (xmin-ps10 <= TabX) );
    imax = find((TabX <= xmax+ps10) & (xmax-ps10 <= TabX) );
    subplot(3,3,ix+6); 
    plot(TabX(1:imin),TabFmax(1:imin),':'); hold on;
    plot(TabX(imin:imax),TabFmax(imin:imax)); 
    plot(TabX(imax:end),TabFmax(imax:end),':'); 
    V=axis; axis([V(1) V(2) 0 FqMax*5]);
    hold off;
    grid on; if ix==1, ylabel('Fqi max'); end
    xlabel(['Dplacement selon O' letmin(ix)]);
    disp ([num2str(TabX(imin)) ' <= ' letmaj(ix) ' <= ' num2str(TabX(imax))]);
end





